#include <stdio.h>
#include <stdlib.h>

#define noCustomers 20

typedef enum {FALSE, TRUE} State;

typedef struct    {
    char name[20];
    double balance;
    State active;
} Account;

Account Bank[20];

double readDNumber() {
	double x;

	char line[100];
	gets(line);
	
	return atof(line);
}

int readINumber() {
	double x;

	char line[100];
	gets(line);
	
	return atoi(line);
}

char getch()
{
	char line[100];
	gets(line);
	return line[0];
}

void doTransaction(int thesi)    {
        char ch;
        double amount;
        printf("\nChoose (D)eposit (W)ithdraw (E)xit  :  ");
        ch = getch();
        switch(ch)   {
            case 'e' :
            case 'E' : 
			             break;       
            case 'd' :
            case 'D' :
                        printf("Amount : ");
                        amount = readDNumber();
                        Bank[thesi].balance += amount;
                        break;
            case 'w' :
            case 'W' :        
                        printf("Amount : ");
						amount = readDNumber();
                        if(Bank[thesi].balance - amount >= 0)
                           Bank[thesi].balance -= amount;
                        break;                       
            default: 
              printf("Error : %c is not a valid option\n", ch);
        }    
    }    


int showAccounts(void) {
    int i;
    int total = 0;
    
    printf("\n");
    for(i = 0; i < noCustomers; i++)
      if(Bank[i].active == TRUE) {
         printf("%d ) \t %s \t %lf \n", i , Bank[i].name , Bank[i].balance);
         total = total + 1;
      }    
    
	if(total == 0)  {
        printf("\n\nThe Bank is empty.\n\n");
    }
         
    return total;         
}


int ListAccounts(void) {
    int i;
    int pos;
    
    if(showAccounts() > 0)    {
       printf("Choose an account number : ");
       pos = readINumber();

      if(((pos >= 0) && (pos < noCustomers)) && (Bank[pos].active == TRUE)){
          return pos;
       }
      else {
           printf("\nError : %d is not a valid option.\n", pos);
        }
    }  
    return -1;         
}

void DeleteAccount(void){
    int pos;
    
    if((pos = ListAccounts()) > -1)
       Bank[pos].active = FALSE;
} 

void TransAccount(void){
    int pos;
    
    if((pos = ListAccounts()) > -1)
       doTransaction(pos);
}    


void NewAccount(void) {
    char name[20];
    int i, pos = -1;
    
    for(i = 0; i < noCustomers; i++)
      if(Bank[i].active == FALSE)  {
         pos = i;  
         break;
      }    
      
    if(pos < 0)  {
        printf("\nThe bank array is full.\n");
    }
    else  {
        printf("Type customer name : ");
        scanf("%s", name);
        char ch = getch();
        
        Bank[pos].active = TRUE;
        Bank[pos].balance = 0.0;
        strcpy(Bank[pos].name, name);
        
    }          
}



int DisplayMenu(void) {
    char ch, temp;
    int  t, ans = -1;

    printf("(N) New Account\n");
    printf("(D) Delete Account\n");
    printf("(T) Transaction\n");
    printf("(L) List Accounts\n");;
    printf("(E) Exit\n");
    printf("Type your choice : "); 
	//scanf("%c", &ch); scanf("%c", &temp);
	
	ch = getch();
    switch(ch)  {
            case 'n' :
            case 'N' :
                        NewAccount();  break;
            case 'd' :
            case 'D' :        
                        DeleteAccount();   break; 
            case 't' :
            case 'T' :
                        TransAccount();   break;
            case 'l' :
            case 'L' :
                        t = showAccounts();   break;    
            case 'e' :
            case 'E' :
                        ans = 1;     break;                                              
            default:
                printf("Error : %c is not a valid option\n", ch);      
       }           
       return ans;
}    

void initializeBank(void) {
 int i;
 for(i = 0; i < noCustomers; i++)
      Bank[i].active = FALSE;
}

 
int main(int argc, char *argv[]){
  initializeBank();
    
  while(DisplayMenu() < 0) {}
      
  return 0;
}




